<?php

/* Enter description here ...
 * @package Logic
 * @author  alessandrobartels
 */

class Demonstrativo {

    const MAX_ORDEM_TP_EVENTO = 9;

    private $_descricao;
    private $_mesCompetencia;
    private $_elementos = array();
    private $_cabecalho;

    /* Enter description here ...
     * @param string $descricao       Descricao.
     * @param string $mes_competencia Data.
     */

    public function __construct($descricao, $mes_competencia){
        $this->_descricao = $descricao;
        $this->_mesCompetencia = $mes_competencia;
    }

    /* Enter description here ...
     * @param Elemento $elemento        Elemento.
     * @param integer  $ordem_impressao Numero da ordem de impressao.
     * @return Elemento
     */

    public function addElemento(Elemento $elemento = null, $ordem_impressao = null, $ordenacao = null){
        $elemento = new Elemento($this->_cabecalho, $ordem_impressao, $ordenacao);
        $this->_elementos[] = $elemento;
        return $elemento;
    }

    public function montaCabecalho($matricula, $nrVinculo, $nomePessoa, $salario = null, $dtAdmissao = null,
                                   $dtRescisao = null, $periodoGozo = null,$dias_uteis_dsr = null, $afastamento = null){

        //Recebe dias úteis e feriados para montar no cabeçalho Borba 04/03/2013
        $this->_cabecalho = '<section id="header-simulator" class="cols-8-8">';
            $this->_cabecalho .= '<hgroup>';
                $this->_cabecalho .= '<h4>';
                    $this->_cabecalho .= '<span class="mseparator"></span>';
                    $this->_cabecalho .= '<span>';
                        $this->_cabecalho .= $nomePessoa .'&nbsp;&nbsp;&nbsp;-&nbsp;&nbsp;&nbsp;'.$nrVinculo;
                    $this->_cabecalho .= '</span>';
                $this->_cabecalho .= '</h4>';
                $this->_cabecalho .= '<h5>';
                    $this->_cabecalho .= '<span>';
                        $this->_cabecalho .= '<b>Matricula: </b></i>'.$matricula.'</i>';
                    $this->_cabecalho .= '</span>';
                    $this->_cabecalho .= '<span>';
                    //Marcelo 22/05/2014 - Retirada do espaco apos a virgula e ponto na funcao number_format
                        if ($salario !== null) {$this->_cabecalho .= '<b>Salario: </b><i>'.number_format($salario, 2, ',','.').'</i>';}
                    $this->_cabecalho .= '</span>';
                    $this->_cabecalho .= '<span>';
                        if ($dtAdmissao !== null) {$this->_cabecalho .= '<b>Admissao: </b><i>'.$dtAdmissao.'</i>';}
                    $this->_cabecalho .= '</span>';
                    $this->_cabecalho .= '<span>';
                        if ($dtRescisao !== null) {$this->_cabecalho .= '<b>Rescisao: </b><i>'.$dtRescisao.'</i>';}
                    $this->_cabecalho .= '</span>';
                    $this->_cabecalho .= '<span>';
                        if ($periodoGozo !== null) {$this->_cabecalho .= '<b>Ferias: </b><i>'.$periodoGozo.'</i>';}
                    $this->_cabecalho .= '</span>';
                    $this->_cabecalho .= '<span>';
                        if ($dias_uteis_dsr !== null) {$this->_cabecalho .= $dias_uteis_dsr;}
                    $this->_cabecalho .= '</span>';
                    $this->_cabecalho .= '<span>';
                        if ($afastamento !== null) {$this->_cabecalho .= '<b>Ferias: </b><i>'.$afastamento.'</i>';}
                    $this->_cabecalho .= '</span>';
                $this->_cabecalho .= '</h5>';
            $this->_cabecalho .= '</hgroup>';
        $this->_cabecalho .= '</section>';

    }

    /* Enter description here ...
     * @return Ambigous <string, unknown>
     */

    public function __toString(){

        usort($this->_elementos, array('Demonstrativo', 'comparaOrdemImpressao'));
            $header = '<span style="font-size: 12px;font-weight: normal;text-transform: uppercase;">';
//                switch($this->_descricao){
//                    case 'CALC_FOLHA':
//                        $header .= 'Cálculo de Folha Mensal';
//                        break;
//                    case 'CALC_RESCISAO':
//                        $header .= 'Cálculo de Rescisão';
//                        break;
//                    case 'CALC_ADIANT_13SAL':
//                        $header .= 'Cálculo de 13º Salário - Adiantamento';
//                        break;
//                    default:
//                        $header .= $this->_descricao;
//                        break;
//                }
//            $header .= '</span>';
//            $header .= '<span>&nbsp;&nbsp;&nbsp;-&nbsp;&nbsp;&nbsp;';
//                $header .= $this->_mesCompetencia;
            $header .= '</span>';

        foreach ($this->_elementos as $elemento) {
            $header .= $elemento;
        }
        //Marcelo 22/05/2014 - Alinhamento a direita do Valor na Simulacao --> valor_evento
        $header .= <<<HTML
            <style type="text/css">
                #header-simulator hgroup h4{font-size: 12px;font-weight: normal;text-transform: uppercase;font-family: inherit;padding-bottom: 10px;}
                #header-simulator hgroup h5{font-size: 10px;font-weight: normal;text-transform: uppercase;padding-bottom: 10px;}
                #header-simulator hgroup h5 span{padding-right: 15px;}
                .resultado table thead tr:first-child{background: #999999;background: -moz-linear-gradient(top, #b8b8b8 0%, #999999 100%);background: -webkit-gradient(linear, left top, left bottom, color-stop(0%, #b8b8b8), color-stop(100%, #999999));background: -webkit-linear-gradient(top, #b8b8b8 0%, #999999 100%);background: -o-linear-gradient(top, #b8b8b8 0%, #999999 100%);background: -ms-linear-gradient(top, #b8b8b8 0%, #999999 100%);background: linear-gradient(to bottom, #b8b8b8 0%, #999999 100%);filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#b8b8b8', endColorstr='#999999',GradientType=0 );height: 23px;color: #ffffff;-webkit-text-shadow: 1px 1px 1px #3d3d3d;-moz-text-shadow: 1px 1px 1px #3d3d3d;text-shadow: 1px 1px 1px #3d3d3d;}
                .resultado table thead tr:first-child th:first-child{border-top-left-radius: 4px;}
                .resultado table thead tr:first-child th:last-child{border-top-right-radius: 4px;}
                .resultado table tbody{background: #d9d9d9;}
                .resultado table tbody:last-child tr:last-child td:last-child{border-bottom-right-radius: 4px;}
                .resultado table tbody:last-child tr:last-child td:first-child{border-bottom-left-radius: 4px;}
                .resultado table tbody tr{height: 20px;}
                .resultado table tbody tr td {padding-left: 5px;text-align: left;}
                .valor_evento {text-align: right !important;}
            </style>
HTML;

        return $header;
    }

    /* Enter description here ...
     * @param object $objPosAtual Objeto.
     * @param object $objProxPos  Objeto.
     * @return integer
     */

    public static function comparaOrdemImpressao($objPosAtual, $objProxPos){

        try{
            $objPosAtual->getOrdemTipoEvento();
        } catch (Exception $e){
            tk_warning($e->getMessage());
            TkDebug::getBackTrace();
        }

        $corrente = (string)$objPosAtual->getOrdemImpressao();
        $proxima = (string)$objProxPos->getOrdemImpressao();

        $tamCorrente = strlen($corrente);
        $tamProxima = strlen($proxima);

        $corrente = str_pad($corrente, self::MAX_ORDEM_TP_EVENTO, '0', STR_PAD_LEFT);
        $corrente = str_pad($corrente, self::MAX_ORDEM_TP_EVENTO + 1, $objPosAtual->getOrdemTipoEvento(), STR_PAD_LEFT);

        $proxima = str_pad($proxima, self::MAX_ORDEM_TP_EVENTO, '0', STR_PAD_LEFT);
        $proxima = str_pad($proxima, self::MAX_ORDEM_TP_EVENTO + 1, $objProxPos->getOrdemTipoEvento(), STR_PAD_LEFT);

        if ($corrente > $proxima) {
            return 1;
        } else {
            return -1;
        }

    }

}

/* Enter description here ...
 * @package Logic
 * @author  alessandrobartels
 */

class Elemento{

    private $_descricao;
    private $_ordem_impressao;
    private $_ordemTipoEvento;
    private $_itens = array();

    /* Enter description here ...
     * @param string  $descricao       Descricao.
     * @param integer $ordem_impressao Ordem de impressao.
     */

    public function __construct($descricao, $ordem_impressao = null, $ordenacao = null){
        $this->_descricao = $descricao;
        $this->_ordem_impressao = $ordem_impressao;
        $this->_ordemTipoEvento = $ordenacao;
    }

    /* Enter description here ...
     * @return string
     */

    public function getDescricao(){
        return $this->_descricao;
    }

    /* Enter description here ...
     * @return integer
     */

    public function getOrdemImpressao(){
        return $this->_ordem_impressao;
    }

    /* Enter description here ...
     * @return string
     */

    public function getOrdemTipoEvento(){
        return $this->_ordemTipoEvento;
    }

    /* Enter description here ...
     * @param string  $item            Item.
     * @param integer $nr_calculo      Numero Calculo.
     * @param integer $ordem_impressao Ordem de Impressao.
     * @param string  $nrvinculom      V�nculo.
     * @return Item
     */

    public function addItem($item, $nr_calculo, $ordem_impressao = null, $nrvinculom = null){
        $item = new Item($item, $nr_calculo, $ordem_impressao, $nrvinculom);
        $this->_itens[] = $item;
        return $item;
    }

    /* Enter description here ...
     * @return string
     */

    public function __toString(){

        $itens = $this->_itens;
        if (count($itens) > 0) {
            // usort($this->_itens, array('Demonstrativo', 'comparaOrdemImpressao'));.
            // usort($this->_itens, array('Demonstrativo', 'comparaTipoEvento'));.
            $saida = $this->_descricao;
            foreach ($this->_itens as $item) {
                $saida .= $item;
            }
            return $saida;
        }

    }

}

/* Enter description here ...
 * @package Logic
 * @author  nataliacesario
 */

class Item{

    private $_nrvinculom;
    private $_matricula;
    private $_nrCalculo;
    private $_descricao;
    private $_ordemImpressao;
    private $_eventos = array();

    /* Enter description here ...
     * @param string $descricao       Descricao.
     * @param string $nr_calculo      Numero Calculo.
     * @param string $ordem_impressao Ordem de Impressao.
     * @param string $nrvinculom      V�nculo.
     */

    public function __construct($descricao, $nr_calculo, $ordem_impressao = null, $nrvinculom = null){
        $this->_nrvinculom = $nrvinculom;
        $this->_nrCalculo = $nr_calculo;

        $this->_descricao = $descricao;
        $this->_ordemImpressao = $ordem_impressao;
    }

    /* Enter description here ...
     * @return string
     */

    public function getOrdemImpressao(){
        return $this->_ordemImpressao;
    }

    /* Enter description here ...
     * @param string  $dt_ocorrencia   Data de Ocorrencia.
     * @param string  $tipo            Tipo.
     * @param integer $nr              Numero.
     * @param string  $evento          Evento.
     * @param string  $referencia      Referencia.
     * @param string  $tipo_ref        Tipo de Referencia.
     * @param string  $demon_calc      Demonstracao Calculo.
     * @param string  $valor           Valor.
     * @param string  $ordem_impressao Ordem Impressao.
     * @param string  $ordemTipoEvento Ordem do Tipo de Evento.
     * @return Evento
     */

    public function addEvento($dt_ocorrencia, $tipo, $nr, $evento, $referencia, $tipo_ref, $demon_calc, $valor,
                              $ordem_impressao,$ordemTipoEvento){
        $evento = new Evento($this->_descricao, $dt_ocorrencia, $tipo, $nr, $evento, $referencia, $tipo_ref, $demon_calc, $valor,
            $ordem_impressao, $ordemTipoEvento);

        $this->_eventos[] = $evento;
        return $evento;
    }

    /* Enter description here ...
     * @return string
     */

    public function __toString(){

        //Ordena o vetor de objetos conforme funcao comparaOrdemEventos()
        usort($this->_eventos, array('Demonstrativo', 'comparaOrdemImpressao'));
        $saida = '';
        $i = 1;
        foreach ($this->_eventos as $evento) {
            if ($i === 1) {
                $saida .= '<div style="padding:5px;"><span>'.$this->_nrCalculo . ' - </span><span>'.$this->_descricao.'<span/></div>';

                $saida .= <<<HTML
                    <section class="resultado">
                        <table class="tabled">
                            <thead>
                                <tr>
                                    <th width="5%">Data</th>
                                    <th width="5%">Tipo</th>
                                    <th width="5%">Nr</th>
                                    <th width="50%">Evento</th>
                                    <th width="5%">Ref.</th>
                                    <th width="5%">TpRef.</th>
                                    <th width="5%">Dem</th>
                                    <th width="5%">Valor</th>
                                </tr>
                            </thead>
                            <tbody>
HTML;
            }
            $saida .= $evento;
            $i++;
        }

        if ($i > 1) {
            $saida .= <<<HTML
                </tbody>
            </table>
        </section>
HTML;
        }

        return (string)$saida;
    }

}

/* Enter description here ...
 * @package Logic
 * @author  nataliacesario
 */

class Evento{

    private $_dataOcorrencia;
    private $_tipo;
    private $_mov;
    private $_nr;
    private $_descricao;
    private $_referencia;
    private $_tipoReferencia;
    private $_demonCalc;
    private $_valor;
    private $_ordemImpressao;
    private $_ordemTipoEvento;

    /* Enter description here ...
     * @param string  $dt_ocorrencia   Data da Ocorrencia.
     * @param string  $tipo            Tipo.
     * @param integer $nr              Numero.
     * @param string  $descricao       Descricao.
     * @param string  $referencia      Referencia.
     * @param string  $tipo_ref        Tipo de Referencia.
     * @param string  $demon_calc      Demonstracao de Calculo.
     * @param float   $valor           Valor.
     * @param string  $ordem_impressao Ordem Impressao.
     * @param string  $ordemTipoEvento Ordem do Tipo de Evento.
     */

    public function __construct($mov, $dt_ocorrencia, $tipo, $nr, $descricao, $referencia, $tipo_ref, $demon_calc, $valor,
                                $ordem_impressao,$ordemTipoEvento){

        if($dt_ocorrencia){
            $this->_dataOcorrencia = $dt_ocorrencia;
        }else{
            $this->_dataOcorrencia = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
        }
        $this->_tipo = $tipo;
        $this->_nr = $nr;
        $this->_mov = $mov;
        $this->_descricao = $descricao;
        $this->_referencia = $referencia;
        $this->_tipoReferencia = $tipo_ref;
        $this->_demonCalc = $demon_calc;
        $this->_valor = $valor;
        $this->_ordemImpressao = $ordem_impressao;
        $this->_ordemTipoEvento = $ordemTipoEvento;

    }

    /* Enter description here ...
     * @return string
     */

    public function getOrdemImpressao(){
        return $this->_ordemImpressao;
    }

    /* Enter description here ...
     * @return string
     */

    public function getOrdemTipoEvento(){
        return $this->_ordemTipoEvento;
    }

    /* Enter description here ...
     * @return string
     */

    public function __toString(){

        $tipo  = substr($this->_tipo, 0, 4);
        $ref   = (intval(strval($this->_tipoReferencia * 100)) / 100);
        $tpref = strtolower($this->_referencia);
        //Marcelo 22/05/2014 - Retirada do espaco apos a virgula e ponto na funcao number_format
        $valor = number_format($this->_valor, 2, ',','.');

        //BORBA 27/09/2013 Para facilitar a leitura os eventos de líquido ficam em negrito.
        $negrito='';
        if($this->_nr==3030 || $this->_nr==3040 ||$this->_nr==3050){
        $negrito='style="font-weight: bold;"';
        }

        $saida = '<tr class="'.$this->_tipo.'"'.$negrito.'>
                <td>'.$this->_dataOcorrencia.'</td>
                <td>'.$tipo.'</td>
                <td>'.$this->_nr.'</td>';

        if(($this->_mov == 'RESCISAO FERIAS PROPORCIONAIS' ) ||
            ($this->_mov == 'RESCISAO 13 SALARIO' ) ||
            ($this->_mov == 'AVISO PREVIO' ) ||
            ($this->_mov == 'RESCISAO FERIAS VENCIDAS' )){

            $saida .= '<td>Média - '.$this->_descricao.'</td>';

        }else{
            $saida .= '<td>'.$this->_descricao.'</td>';
        }

        $saida .= '<td>'.$ref.'</td>
                <td>'.$tpref.'</td>
                <td class="align_center">'.$this->_demonCalc.'</td>
                <td class="align_right valor_evento" >'.$valor.'</td>
            </tr>';

        return $saida;
    }

}