/*+
|                                               |
|     Trigger: DTULTATU_CANDIDATO               |  
|     Tabela : CANDIDATO                        |
|                                               |
|     Criao:                                  |
|     19/07/2007 - Luiz Passos                  |
|                                               |
+*/


create or replace TRIGGER DTULTATU_CANDIDATO
BEFORE INSERT OR UPDATE OR DELETE
ON CANDIDATO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUCAND := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDEMPRESA,0)         <>  NVL(:NEW.CDEMPRESA,0))       OR
           (NVL(:OLD.CDCAND,0)          <>  NVL(:NEW.CDCAND,0))          OR
           (NVL(:OLD.CDCARGO,0)         <>  NVL(:NEW.CDCARGO,0))         OR
           (NVL(:OLD.CDFILIAL,0)        <>  NVL(:NEW.CDFILIAL,0))        OR
           (NVL(:OLD.NRCPFCANDI,0)      <>  NVL(:NEW.NRCPFCANDI,0))      OR
           (NVL(:OLD.CDORIGCAND,0)      <>  NVL(:NEW.CDORIGCAND,0))      OR
           (NVL(:OLD.NMCANDI,0)         <>  NVL(:NEW.NMCANDI,0))         OR
           (NVL(:OLD.NRPISCANDI,0)      <>  NVL(:NEW.NRPISCANDI,0))      OR
           (NVL(:OLD.NRRGCANDI,0)       <>  NVL(:NEW.NRRGCANDI,0))       OR           
           (NVL(:OLD.DSENDECANDI,0)     <>  NVL(:NEW.DSENDECANDI,0))     OR
           (NVL(:OLD.NMBAIRCANDI,0)     <>  NVL(:NEW.NMBAIRCANDI,0))     OR
           (NVL(:OLD.NRCEPCANDI,0)      <>  NVL(:NEW.NRCEPCANDI,0))      OR
           (NVL(:OLD.NRFONECANDI,0)     <>  NVL(:NEW.NRFONECANDI,0))     OR
           (NVL(:OLD.IDSEXOCAND,0)      <>  NVL(:NEW.IDSEXOCAND,0))      OR 
           (NVL(:OLD.CDEXRGCAND,0)      <>  NVL(:NEW.CDEXRGCAND,0))      OR
           (NVL(:OLD.NRCTPSCAND,0)      <>  NVL(:NEW.NRCTPSCAND,0))      OR
           (NVL(:OLD.SGUFCTPSCAN,0)     <>  NVL(:NEW.SGUFCTPSCAN,0))     OR           
           (NVL(:OLD.NRTIELCAND,0)      <>  NVL(:NEW.NRTIELCAND,0))      OR
           (NVL(:OLD.NRZOELCAND,0)      <>  NVL(:NEW.NRZOELCAND,0))      OR
           (NVL(:OLD.NRSEELCAND,0)      <>  NVL(:NEW.NRSEELCAND,0))      OR
           (NVL(:OLD.SGRGPRCAND,0)      <>  NVL(:NEW.SGRGPRCAND,0))      OR
           (NVL(:OLD.NRRGPRCAND,0)      <>  NVL(:NEW.NRRGPRCAND,0))      OR
           (NVL(:OLD.NRCERRECAND,0)     <>  NVL(:NEW.NRCERRECAND,0))     OR
           (NVL(:OLD.CDCATRECAND,0)     <>  NVL(:NEW.CDCATRECAND,0))     OR
           (NVL(:OLD.CDESPRECAND,0)     <>  NVL(:NEW.CDESPRECAND,0))     OR
           (NVL(:OLD.NMPAICAND,0)       <>  NVL(:NEW.NMPAICAND,0))       OR
           (NVL(:OLD.DSPRPAICAND,0)     <>  NVL(:NEW.DSPRPAICAND,0))     OR           
           (NVL(:OLD.NMMAECAND,0)       <>  NVL(:NEW.NMMAECAND,0))       OR
           (NVL(:OLD.DSPRMAECAND,0)     <>  NVL(:NEW.DSPRMAECAND,0))     OR
           (NVL(:OLD.VRSALCAND,0)       <>  NVL(:NEW.VRSALCAND,0))       OR
           (NVL(:OLD.CDESCOLARIDADE,0)  <>  NVL(:NEW.CDESCOLARIDADE,0))  OR
           (NVL(:OLD.CDESTACIVIL,0)     <>  NVL(:NEW.CDESTACIVIL,0))     OR
           (NVL(:OLD.CDNACIONALIDADE,0) <>  NVL(:NEW.CDNACIONALIDADE,0)) OR
           (NVL(:OLD.NRSERIECTPSC,0)    <>  NVL(:NEW.NRSERIECTPSC,0))    OR
           (NVL(:OLD.CDPAIS,0)          <>  NVL(:NEW.CDPAIS,0))          OR
           (NVL(:OLD.SGESTADO,0)        <>  NVL(:NEW.SGESTADO,0))        OR
           (NVL(:OLD.CDMUNICIPIO,0)     <>  NVL(:NEW.CDMUNICIPIO,0))     OR           
           (NVL(:OLD.CDDEPTO,0)         <>  NVL(:NEW.CDDEPTO,0))         OR
           (NVL(:OLD.CDPAISNASCAN ,0)   <>  NVL(:NEW.CDPAISNASCAN ,0))   OR
           (NVL(:OLD.SGESTANASCAN,0)    <>  NVL(:NEW.SGESTANASCAN,0))    OR
           (NVL(:OLD.CDMUNINASCAN,0)    <>  NVL(:NEW.CDMUNINASCAN,0))    OR
           (NVL(:OLD.CDOPEENTCAND,0)    <>  NVL(:NEW.CDOPEENTCAND,0))    OR
           (NVL(:OLD.NRFONE2CAND,0)     <>  NVL(:NEW.NRFONE2CAND,0))     OR
           (NVL(:OLD.DSEMAILCAND,0)     <>  NVL(:NEW.DSEMAILCAND,0))     OR
           (NVL(:OLD.IDAPOPAICAND,0)    <>  NVL(:NEW.IDAPOPAICAND,0))    OR           
           (NVL(:OLD.IDAPOMAECAND,0)    <>  NVL(:NEW.IDAPOMAECAND,0))    OR
           (NVL(:OLD.CDSITUCAND,0)      <>  NVL(:NEW.CDSITUCAND,0))      OR
           (NVL(:OLD.NMLONASCAND,0)     <>  NVL(:NEW.NMLONASCAND,0))     OR
           (NVL(:OLD.NRAUDITORIA,0)     <>  NVL(:NEW.NRAUDITORIA,0))     OR
           (NVL(:OLD.CDSETOR,0)         <>  NVL(:NEW.CDSETOR,0))         OR
           (NVL(:OLD.DTNASCCANDI, TO_DATE('31/12/1899','DD/MM/YYYY')) <> NVL(:NEW.DTNASCCANDI,TO_DATE ('31/12/1899','DD/MM/YYYY'))) OR           
           (NVL(:OLD.DTENTREVCAND,TO_DATE('31/12/1899','DD/MM/YYYY')) <> NVL(:NEW.DTENTREVCAND,TO_DATE('31/12/1899','DD/MM/YYYY'))) OR
           (NVL(:OLD.DTNASMAECAND,TO_DATE('31/12/1899','DD/MM/YYYY')) <> NVL(:NEW.DTNASMAECAND,TO_DATE('31/12/1899','DD/MM/YYYY'))) OR
           (NVL(:OLD.DTNASPAICAND,TO_DATE('31/12/1899','DD/MM/YYYY')) <> NVL(:NEW.DTNASPAICAND,TO_DATE('31/12/1899','DD/MM/YYYY'))) OR
           (NVL(:OLD.DTCADACAND,  TO_DATE('31/12/1899','DD/MM/YYYY')) <> NVL(:NEW.DTCADACAND,TO_DATE  ('31/12/1899','DD/MM/YYYY'))) OR
           (NVL(:OLD.DTPISCAND,   TO_DATE('31/12/1899','DD/MM/YYYY')) <> NVL(:NEW.DTPISCAND,TO_DATE   ('31/12/1899','DD/MM/YYYY'))) OR
           (NVL(:OLD.DTEXRGCAND,  TO_DATE('31/12/1899','DD/MM/YYYY')) <> NVL(:NEW.DTEXRGCAND,TO_DATE  ('31/12/1899','DD/MM/YYYY'))) THEN
           
              :NEW.DTULTATUCAND := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('CANDIDATO'  , '', 'CDEMPRESA='||:OLD.CDEMPRESA||';CDCAND='||:OLD.CDCAND||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE CANDIDATO MODIFY DTULTATUCAND DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_CANDIDATO','5.01.008'); END;
/

